// InstPrivIoXP.c

#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <winioctl.h>
#include <process.h>

#include "PrivIoXP_IOCTL.h"
#include "SetPrivIoXP.h"

#define EGO "InstPrivIoXP"   /* our name */

static BOOL bVerbose = TRUE;

static void usage(void)
{
    fprintf(stderr, "Install direct I/O port access driver (Windows NT/2000/XP)\n");
    fprintf(stderr, "usage: "EGO" [-v|-q|-?] [-lptn]\n");
    exit(1);
}

int main(int argc, char **argv)
{
    int nPort = 0;
    HANDLE hDriver = NULL;

    setvbuf(stderr, (char *)NULL, _IONBF, 0); // unbuffer output

    for (--argc, ++argv  ; argc; --argc, ++argv) {
        if (!strcmp(*argv, "/?") || !strcmp(*argv, "-?") ||
                             !strcmp(*argv, "/h") || !strcmp(*argv, "-h") ||
                             !strcmp(*argv, "-help")) {
            usage();
        } else if (!strcmp(*argv, "/v") || !strcmp(*argv, "-v")) {
            bVerbose = TRUE;
        } else if (!strcmp(*argv, "/q") || !strcmp(*argv, "-q")) {
            bVerbose = FALSE;
        } else if (!strncmp(*argv, "-lpt", 4)) {
            nPort = atoi(*argv + 4);
            if (nPort < 1 || nPort > 2) {
                fprintf(stderr, 
                    EGO": no such LPT port (%s)!"
                    "  Use -lpt0, -lpt1 or -lpt2.\n", *argv);
                exit(1);
            }
        } else if (**argv == '/' || **argv == '-') {
            fprintf(stderr, EGO": unknown option (%s)!\n", *argv);
            fprintf(stderr, "Hint: For help use \""EGO" -?\"\n");
            return 1;
        } else {
            break;
        }
    }

    if (argc) usage();

    if (!bIsWindowsNT()) {
        fprintf(stderr, EGO": Only works with Windows NT (Windows NT/2000/XP)!\n");
        return 1;
    }

    if (bVerbose) fprintf(stderr, EGO": using "DRIVER_NAME" driver\n");

    if (!SetPrivIoXP(bVerbose, EGO": ", TRUE, nPort, NULL, NULL, NULL, NULL, 0)) {
        goto abort;
    }

    return 0;  // no errors

abort:
    if (hDriver) CloseHandle(hDriver);
    return 1;
}
